import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:nuntio_hera/hera.pb.dart';
import 'package:nuntio_hera/hera/hera.dart';
import 'package:nuntio_hera/hera_ui/hera_ui.dart';
import 'package:nuntio_hera/hera_ui/models.dart';
import 'package:with_ui_example/home/home.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Hera.initialize(
    debug: true,
    apiUrl: 'http://127.0.0.1:9000',
  );
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  Widget build(BuildContext context) {
    return HeraUI(
      heraText: HeraText(
          loginTitle: "Social By Nuntio",
          loginSubtitle:
              "Stay in touch with friends & family without wasting your time"),
      heraTextStyle: HeraTextStyle(),
      brightness: Brightness.light,
      child: Home(),
    );
  }
}
