import 'package:flutter/cupertino.dart';
import 'package:flutter_svg/svg.dart';
import 'package:nuntio_hera/hera.pb.dart';
import 'package:nuntio_hera/hera_ui/components/nuntio_button.dart';
import 'package:nuntio_hera/hera_ui/models.dart';
import '../../../../hera/hera.dart';

Widget ContinueWithButton({
  required HeraStyle heraStyle,
  required HeraColor heraColor,
  required HeraTextStyle heraTextStyle,
  required OidcProvider oidcProvider,
  required Function loginSuccess,
}) {
  return NuntioButton(
    width: heraStyle.buttonWidth,
    height: heraStyle.buttonHeight,
    padding: EdgeInsets.zero,
    filled: true,
    color: heraColor.oidcColor,
    onPressed: () => {
      Hera.loginWithOidc(
              type: oidcProvider.type, authorizationUrl: oidcProvider.url)
          .then((value) => {loginSuccess()})
    },
    child: Row(
      crossAxisAlignment: CrossAxisAlignment.center,
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        SvgPicture.network(
          oidcProvider.logo,
          width: 25,
          color: heraTextStyle.oidcButtonTextStyle.color,
          placeholderBuilder: (context) {
            return Image(
                image: NetworkImage(oidcProvider.logo),
                height: 25,
                color: heraTextStyle.oidcButtonTextStyle.color);
          },
        ),
        SizedBox(
          width: 5,
        ),
        Text(
          oidcProvider.name,
          textAlign: TextAlign.center,
          style: heraTextStyle.oidcButtonTextStyle,
        ),
      ],
    ),
  );
}
