import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../../hera.pbenum.dart';

const white = Color(0xffFFFFFF);
const black = Color(0xff131313);
const letterSpacing = 1.1;

class HeraText {
  // general
  late String errorTitle;
  late String errorSubtitle;
  late String noWifiTitle;
  late String noWifiSubtitle;
  late String usernameLabelText;
  late String emailLabelText;
  late String phoneLabelText;
  late String passwordLabelText;
  late String repeatPasswordLabelText;
  late String invalidUsernameText;
  late String invalidEmailText;
  late String invalidPhoneText;
  late String invalidPasswordText;
  late String invalidIdentifierText;

  // _general
  String? _missingIdentifierText;
  String? _missingPasswordText;
  String? _errorTitle;
  String? _errorSubtitle;
  String? _noWifiTitle;
  String? _noWifiSubtitle;
  String? _usernameLabelText;
  String? _emailLabelText;
  String? _phoneLabelText;
  String? _passwordLabelText;
  String? _repeatPasswordLabelText;
  String? _invalidUsernameText;
  String? _invalidEmailText;
  String? _invalidPhoneText;
  String? _invalidPasswordText;
  String? _invalidIdentifierText;

  // login
  late String loginTitle;
  late String loginSubtitle;
  late String identifierLabelText;
  late String loginButtonText;
  late String forgotPasswordButtonText;
  late String orLoginText;
  late String continueWithText;
  late String dontHaveAnAccountButtonText;

  // _login
  String? _loginTitle;
  String? _loginSubtitle;
  String? _identifierLabelText;
  String? _loginButtonText;
  String? _forgotPasswordButtonText;
  String? _orLoginText;
  String? _continueWithText;
  String? _dontHaveAnAccountButtonText;

  // register
  late String registerTitle;
  late String registerContactSubtitle;
  late String nextButtonText;
  late String alreadyHaveAccountButtonText;
  late String registerPasswordSubtitle;
  late String registerButtonText;
  late String passwordContainsEightCharsText;
  late String passwordContainsSpecialText;
  late String passwordContainsNumberText;
  late String passwordsMustMatchText;

  // _register
  String? _registerTitle;
  String? _registerContactSubtitle;
  String? _nextButtonText;
  String? _alreadyHaveAccountButtonText;
  String? _registerPasswordSubtitle;
  String? _registerButtonText;
  String? _passwordContainsEightCharsText;
  String? _passwordContainsSpecialText;
  String? _passwordContainsNumberText;
  String? _passwordsMustMatchText;

  // verify-page
  late String verifyIdentifierTitle;
  late String verifyIdentifierSubtitle;
  late String verifyButtonText;
  late String invalidCodeTitle;
  late String invalidCodeSubtitle;

  // _verify-page
  String? _verifyIdentifierTitle;
  String? _verifyIdentifierSubtitle;
  String? _verifyButtonText;
  String? _invalidCodeTitle;
  String? _invalidCodeSubtitle;

  HeraText({
    // init general
    String? errorTitle,
    String? errorSubtitle,
    String? noWifiTitle,
    String? noWifiSubtitle,
    String? usernameLabelText,
    String? emailLabelText,
    String? phoneLabelText,
    String? passwordLabelText,
    String? repeatPasswordName,
    String? invalidUsernameText,
    String? invalidEmailText,
    String? invalidPhoneText,
    String? invalidPasswordText,
    String? invalidIdentifierText,
    // init login
    String? loginTitle,
    String? loginSubtitle,
    String? identifierLabelText,
    String? loginButtonText,
    String? forgotPasswordButtonText,
    String? orLoginText,
    String? continueWithText,
    String? dontHaveAnAccountButtonText,
    // init register
    String? registerTitle,
    String? registerContactSubtitle,
    String? nextButtonText,
    String? alreadyHaveAccountButtonText,
    String? registerPasswordSubtitle,
    String? registerButtonText,
    String? passwordContainsEightCharsText,
    String? passwordContainsSpecialText,
    String? passwordContainsNumberText,
    String? passwordsMustMatchText,
    String? repeatPasswordLabelText,
    // init verify-page
    String? verifyIdentifierTitle,
    String? verifyIdentifierSubtitle,
    String? verifyButtonText,
    String? invalidCodeTitle,
    String? invalidCodeSubtitle,
  }) {
    //  general
    _errorTitle = errorTitle;
    _errorSubtitle = errorSubtitle;
    _noWifiTitle = noWifiTitle;
    _noWifiSubtitle = noWifiSubtitle;
    _usernameLabelText = usernameLabelText;
    _emailLabelText = emailLabelText;
    _phoneLabelText = phoneLabelText;
    _passwordLabelText = passwordLabelText;
    _repeatPasswordLabelText = repeatPasswordLabelText;
    _invalidUsernameText = invalidUsernameText;
    _invalidEmailText = invalidEmailText;
    _invalidPhoneText = invalidPhoneText;
    _invalidPasswordText = invalidPasswordText;
    _invalidIdentifierText = invalidIdentifierText;
    // login
    _loginTitle = loginTitle;
    _loginSubtitle = loginSubtitle;
    _identifierLabelText = identifierLabelText;
    _loginButtonText = loginButtonText;
    _forgotPasswordButtonText = forgotPasswordButtonText;
    _orLoginText = orLoginText;
    _continueWithText = continueWithText;
    _dontHaveAnAccountButtonText = dontHaveAnAccountButtonText;
    // register
    _registerTitle = registerTitle;
    _registerContactSubtitle = registerContactSubtitle;
    _nextButtonText = nextButtonText;
    _alreadyHaveAccountButtonText = alreadyHaveAccountButtonText;
    _registerPasswordSubtitle = registerPasswordSubtitle;
    _registerButtonText = registerButtonText;
    _passwordContainsEightCharsText = passwordContainsEightCharsText;
    _passwordContainsSpecialText = passwordContainsSpecialText;
    _passwordContainsNumberText = passwordContainsNumberText;
    _passwordsMustMatchText = passwordsMustMatchText;
    // _verify-page
    _verifyIdentifierTitle = verifyIdentifierTitle;
    _verifyIdentifierSubtitle = verifyIdentifierSubtitle;
    _verifyButtonText = verifyButtonText;
    _invalidCodeTitle = invalidCodeTitle;
    _invalidCodeSubtitle = invalidCodeSubtitle;
  }

  build({required List<LoginType> supportedAuthMechanisms}) {
    //  general
    errorTitle = _errorTitle ?? "Something went wrong";
    errorSubtitle =
        _errorSubtitle ?? "We encountered an error. Please try again.";
    noWifiTitle = _noWifiTitle ?? "No wifi connection";
    noWifiSubtitle = _noWifiSubtitle ??
        "We cannot authenticate your credentials without a valid wifi or data connection";
    usernameLabelText = _usernameLabelText ?? "Username";
    emailLabelText = _emailLabelText ?? "Email";
    phoneLabelText = _phoneLabelText ?? "Phone number";
    passwordLabelText = _passwordLabelText ?? "Password";
    repeatPasswordLabelText = _repeatPasswordLabelText ?? "Repeat password";
    invalidUsernameText = _invalidUsernameText ?? "Invalid username";
    invalidEmailText = _invalidEmailText ?? "Invalid email";
    invalidPhoneText = _invalidPhoneText ?? "Invalid phone";
    invalidPasswordText = _invalidPasswordText ?? "Invalid password";

    // login
    loginTitle = _loginTitle ?? "Login";
    loginSubtitle = _loginSubtitle ?? "Fill in the details below to login";
    loginButtonText = _loginButtonText ?? "Login";
    forgotPasswordButtonText =
        _forgotPasswordButtonText ?? "Forgor your password?";
    orLoginText = _orLoginText ?? "or login";
    continueWithText = _continueWithText ?? "Continue with";
    dontHaveAnAccountButtonText =
        _dontHaveAnAccountButtonText ?? "Don't have an account?";

    // register
    registerTitle = _registerTitle ?? "Register an account";
    registerContactSubtitle = _registerContactSubtitle ??
        "Let's get you started. Fill in your contact information below.";
    nextButtonText = _nextButtonText ?? "Next";
    alreadyHaveAccountButtonText =
        _alreadyHaveAccountButtonText ?? "Already have an account? Login";
    registerPasswordSubtitle = _registerPasswordSubtitle ??
        "Let's keep your account secure. Fill in a strong password below.";
    registerButtonText = _registerButtonText ?? "Register";
    passwordContainsEightCharsText =
        _passwordContainsEightCharsText ?? "Min. 8 character";
    passwordContainsSpecialText =
        _passwordContainsSpecialText ?? "Min. 1 special character";
    passwordContainsNumberText = _passwordContainsNumberText ?? "Min. 1 number";
    ;
    passwordsMustMatchText = _passwordsMustMatchText ?? "Password match";

    // verify-page
    verifyIdentifierTitle = _verifyIdentifierTitle ?? "Verify your account";
    verifyIdentifierSubtitle =
        _verifyIdentifierSubtitle ?? "Enter your verification code below.";
    verifyButtonText = _verifyButtonText ?? "Verify";
    invalidCodeTitle = _invalidCodeTitle ?? "Invalid code";
    invalidCodeSubtitle = _invalidCodeSubtitle ??
        "The code that you have provided is invalid or expired. Try again.";

    // this is dependent on login type
    if (supportedAuthMechanisms.contains(LoginType.EMAIL_PASSWORD) &&
        supportedAuthMechanisms.contains(LoginType.PHONE_PASSWORD) &&
        supportedAuthMechanisms.contains(LoginType.USERNAME_PASSWORD)) {
      invalidIdentifierText =
          _invalidIdentifierText ?? "Invalid email, phone, or username";
      identifierLabelText = _identifierLabelText ?? "Email, phone, or username";
    } else if (supportedAuthMechanisms.contains(LoginType.EMAIL_PASSWORD) &&
        supportedAuthMechanisms.contains(LoginType.PHONE_PASSWORD)) {
      invalidIdentifierText =
          _invalidIdentifierText ?? "Invalid email or phone";
      identifierLabelText = _identifierLabelText ?? "Email or phone";
    } else if (supportedAuthMechanisms.contains(LoginType.USERNAME_PASSWORD) &&
        supportedAuthMechanisms.contains(LoginType.PHONE_PASSWORD)) {
      invalidIdentifierText =
          _invalidIdentifierText ?? "Invalid username or phone";
      identifierLabelText = _identifierLabelText ?? "Username or phone";
    } else if (supportedAuthMechanisms.contains(LoginType.USERNAME_PASSWORD) &&
        supportedAuthMechanisms.contains(LoginType.EMAIL_PASSWORD)) {
      invalidIdentifierText =
          _invalidIdentifierText ?? "Invalid username or email";
      identifierLabelText = _identifierLabelText ?? "Username or email";
    } else if (supportedAuthMechanisms.contains(LoginType.USERNAME_PASSWORD)) {
      invalidIdentifierText = _invalidIdentifierText ?? invalidUsernameText;
      identifierLabelText = _identifierLabelText ?? usernameLabelText;
    } else if (supportedAuthMechanisms.contains(LoginType.PHONE_PASSWORD)) {
      invalidIdentifierText = _invalidIdentifierText ?? invalidPhoneText;
      identifierLabelText = _identifierLabelText ?? phoneLabelText;
    } else if (supportedAuthMechanisms.contains(LoginType.EMAIL_PASSWORD)) {
      invalidIdentifierText = _invalidIdentifierText ?? invalidEmailText;
      identifierLabelText = _identifierLabelText ?? emailLabelText;
    }
  }
}

class HeraTextStyle {
  late TextStyle titleStyle;
  late TextStyle subtitleStyle;
  late TextStyle bodyTextStyle;
  late TextStyle loginButtonTextStyle;
  late TextStyle registerButtonTextStyle;
  late TextStyle oidcButtonTextStyle;
  late TextStyle labelStyle;
  TextStyle? _titleStyle;
  TextStyle? _subtitleTextStyle;
  TextStyle? _bodyTextStyle;
  TextStyle? _loginButtonTextStyle;
  TextStyle? _registerButtonTextStyle;
  TextStyle? _labelStyle;
  TextStyle? _oidcButtonTextStyle;

  HeraTextStyle({
    TextStyle? titleStyle,
    TextStyle? subtitleTextStyle,
    TextStyle? bodyTextStyle,
    TextStyle? loginButtonTextStyle,
    TextStyle? registerButtonTextStyle,
    TextStyle? labelStyle,
    TextStyle? oidcButtonTextStyle,
    Brightness? brightness,
  }) {
    _titleStyle = titleStyle;
    _subtitleTextStyle = subtitleTextStyle;
    _bodyTextStyle = bodyTextStyle;
    _loginButtonTextStyle = loginButtonTextStyle;
    _registerButtonTextStyle = registerButtonTextStyle;
    _labelStyle = labelStyle;
    _oidcButtonTextStyle = oidcButtonTextStyle;
  }

  build(Brightness brightness) {
    titleStyle = _titleStyle ??
        TextStyle(
          fontWeight: FontWeight.bold,
          fontSize: 26,
          color: brightness == Brightness.dark ? white : black,
        );
    TextStyle();
    subtitleStyle = _subtitleTextStyle ??
        TextStyle(
            //color: Color(0xffaaacb1),
            color: Color(0xff8F9094),
            fontSize: 20,
            fontWeight: FontWeight.w400);
    bodyTextStyle = _bodyTextStyle ??
        TextStyle(
            color: brightness == Brightness.dark ? white : black, fontSize: 15);
    TextStyle();
    loginButtonTextStyle = _loginButtonTextStyle ??
        TextStyle(
          color: brightness == Brightness.dark ? white : white,
          fontWeight: FontWeight.w500,
          fontSize: 16,
        );
    oidcButtonTextStyle = _oidcButtonTextStyle ??
        TextStyle(
          color: brightness == Brightness.dark ? white : Color(0xff717174),
          fontWeight: FontWeight.w500,
          fontSize: 14,
        );
    registerButtonTextStyle = _registerButtonTextStyle ??
        TextStyle(
          fontWeight: FontWeight.w500,
          color: brightness == Brightness.dark ? black : white,
          fontSize: 16,
        );
    labelStyle = _labelStyle ??
        TextStyle(
          fontWeight: FontWeight.w500,
          fontSize: 14,
          color: brightness == Brightness.dark ? white : black,
        );
  }
}

class HeraColor {
  late Color primaryColor;
  late Color secondaryColor;
  late Color successColor;
  late Color errorColor;
  late Color oidcColor;
  late Color labelColor;
  Color? _primaryColor;
  Color? _secondaryColor;
  Color? _successColor;
  Color? _errorColor;
  Color? _oidcColor;
  Color? _labelColor;

  HeraColor({
    Color? primaryColor,
    Color? secondaryColor,
    Color? successColor,
    Color? errorColor,
    Color? activeColor,
    Color? oidcColor,
    Color? labelColor,
    Brightness? brightness,
  }) {
    _primaryColor = primaryColor;
    _secondaryColor = secondaryColor;
    _successColor = successColor;
    _errorColor = errorColor;
    _oidcColor = oidcColor;
    _labelColor = labelColor;
  }

  build(Brightness brightness) {
    primaryColor = _primaryColor ?? Color(0xff0A6DFF);
    secondaryColor = _secondaryColor ??
        (brightness == Brightness.dark ? white : Color(0xff0A6DFF));
    ;
    successColor = _successColor ?? Color(0xff0A6DFF);
    errorColor = _errorColor ?? Color(0xffFF705B);
    oidcColor = _oidcColor ??
        (brightness == Brightness.dark ? Color(0xff2A2A2A) : Color(0xffF8F8F8));
    labelColor = _labelColor ?? Color(0xff8F9094);
  }
}

class HeraStyle {
  late Color borderColor;
  late Color textFieldColor;
  late double buttonWidth;
  late double buttonHeight;
  late double logoHeight;
  late BoxDecoration background;
  late double spreadRadius;
  late double blurRadius;

  Color? _borderColor;
  Color? _textFieldColor;
  double? _buttonWidth;
  double? _buttonHeight;
  double? _logoHeight;
  BoxDecoration? _background;
  double? _spreadRadius;
  double? _blurRadius;

  build(Brightness brightness) {
    borderColor = _borderColor ??
        (brightness == Brightness.dark ? Color(0xff323232) : Color(0xffEAEEF0));
    textFieldColor =
        _textFieldColor ?? (brightness == Brightness.dark ? black : white);
    buttonWidth = _buttonWidth ?? double.infinity;
    buttonHeight = _buttonHeight ?? 46;
    logoHeight = _logoHeight ?? 100;
    background = _background ??
        (brightness == Brightness.dark
            ? BoxDecoration(
                color: black,
              )
            : BoxDecoration(
                color: white,
              ));
    spreadRadius = _spreadRadius ?? (brightness == Brightness.dark ? 3 : 1.5);
    blurRadius = _blurRadius ?? (brightness == Brightness.dark ? 6 : 3);
  }

  HeraStyle({
    Color? borderColor,
    Color? textFieldColor,
    Color? oidcTextColor,
    double? buttonWidth,
    double? buttonHeight,
    double? logoHeight,
    BoxDecoration? background,
    double? spreadRadius,
    double? blurRadius,
  }) {
    _borderColor = borderColor;
    _textFieldColor = textFieldColor;
    _buttonWidth = buttonWidth;
    _buttonHeight = buttonHeight;
    _logoHeight = logoHeight;
    _background = background;
    _spreadRadius = spreadRadius;
    _blurRadius = blurRadius;
  }
}

class HeraFooter {
  late Widget footer;
  late double height;

  HeraFooter({Widget? footer, double? height}) {
    this.footer = footer ?? SizedBox();
    this.height = height ?? 0.0;
  }
}
